﻿namespace POKEMON_BW2
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class ListBoxDialog : Form
    {
        private Button cancelButton;
        private IContainer components;
        private GroupBox groupBox1;
        protected ArrayList list;
        private ListBox listBox;
        private int max;
        private int min;
        private Button okButton;
        private Button searchButton;
        private ComboBox searchComboBox;
        private TextBox textBox1;

        public ListBoxDialog()
        {
            this.InitializeComponent();
            this.searchComboBox.SelectedIndex = 0;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            int selectedValue = this.SelectedValue;
            this.listBox.DataSource = this.list;
            this.listBox.SelectedValue = selectedValue;
            base.DialogResult = DialogResult.Cancel;
        }

        private void Decide()
        {
            if (this.listBox.SelectedIndex != -1)
            {
                int selectedValue = this.SelectedValue;
                this.listBox.DataSource = this.list;
                this.listBox.SelectedValue = selectedValue;
                base.DialogResult = DialogResult.OK;
            }
            else
            {
                MessageBox.Show("No items selected.", "", MessageBoxButtons.OK, MessageBoxIcon.Hand);
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        public void InitializeArrayList(ArrayList list)
        {
            if ((list == null) || (list.Count < 1))
            {
                throw new Exception("List not Initialized.");
            }
            this.list = list;
            this.listBox.DataSource = list;
            this.listBox.DisplayMember = "Name";
            this.listBox.ValueMember = "Value";
            this.max = -2147483648;
            this.min = 0x7fffffff;
            for (int i = 0; i < list.Count; i++)
            {
                SelectBoxItem item = (SelectBoxItem) list[i];
                int num2 = item.Value;
                if (this.max < num2)
                {
                    this.max = num2;
                }
                if (this.min > num2)
                {
                    this.min = num2;
                }
            }
        }

        private void InitializeComponent()
        {
            this.listBox = new ListBox();
            this.okButton = new Button();
            this.cancelButton = new Button();
            this.groupBox1 = new GroupBox();
            this.textBox1 = new TextBox();
            this.searchComboBox = new ComboBox();
            this.searchButton = new Button();
            this.groupBox1.SuspendLayout();
            base.SuspendLayout();
            this.listBox.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Top;
            this.listBox.FormattingEnabled = true;
            this.listBox.ItemHeight = 12;
            this.listBox.Location = new Point(0, 0);
            this.listBox.Name = "listBox";
            this.listBox.Size = new Size(0x11c, 0x100);
            this.listBox.TabIndex = 0;
            this.listBox.SelectedIndexChanged += new EventHandler(this.listBox_SelectedIndexChanged);
            this.listBox.DoubleClick += new EventHandler(this.listBox_DoubleClick);
            this.listBox.KeyPress += new KeyPressEventHandler(this.listBox_KeyPress);
            this.okButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.okButton.Location = new Point(0x74, 0x148);
            this.okButton.Name = "okButton";
            this.okButton.Size = new Size(0x4b, 0x17);
            this.okButton.TabIndex = 1;
            this.okButton.Text = "OK";
            this.okButton.UseVisualStyleBackColor = true;
            this.okButton.Click += new EventHandler(this.okButton_Click);
            this.cancelButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.cancelButton.DialogResult = DialogResult.Cancel;
            this.cancelButton.Location = new Point(0xc5, 0x148);
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.Size = new Size(0x4b, 0x17);
            this.cancelButton.TabIndex = 2;
            this.cancelButton.Text = "Cancel";
            this.cancelButton.UseVisualStyleBackColor = true;
            this.cancelButton.Click += new EventHandler(this.cancelButton_Click);
            this.groupBox1.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom;
            this.groupBox1.Controls.Add(this.searchButton);
            this.groupBox1.Controls.Add(this.searchComboBox);
            this.groupBox1.Controls.Add(this.textBox1);
            this.groupBox1.Location = new Point(12, 0x10d);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new Size(260, 0x35);
            this.groupBox1.TabIndex = 3;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Filter";
            this.textBox1.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Top;
            this.textBox1.Location = new Point(6, 20);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0x56, 0x13);
            this.textBox1.TabIndex = 0;
            this.searchComboBox.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            this.searchComboBox.DropDownStyle = ComboBoxStyle.DropDownList;
            this.searchComboBox.FormattingEnabled = true;
            this.searchComboBox.Items.AddRange(new object[] { "Begins with", "Includes", "Ends with" });
            this.searchComboBox.Location = new Point(0x62, 20);
            this.searchComboBox.Name = "searchComboBox";
            this.searchComboBox.Size = new Size(0x4b, 20);
            this.searchComboBox.TabIndex = 1;
            this.searchButton.Anchor = AnchorStyles.Right | AnchorStyles.Top;
            this.searchButton.Location = new Point(0xb3, 0x12);
            this.searchButton.Name = "searchButton";
            this.searchButton.Size = new Size(0x4b, 0x17);
            this.searchButton.TabIndex = 2;
            this.searchButton.Text = "Search";
            this.searchButton.UseVisualStyleBackColor = true;
            this.searchButton.Click += new EventHandler(this.searchButton_Click);
            base.AutoScaleDimensions = new SizeF(6f, 12f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.CancelButton = this.cancelButton;
            base.ClientSize = new Size(0x11c, 0x16b);
            base.Controls.Add(this.groupBox1);
            base.Controls.Add(this.cancelButton);
            base.Controls.Add(this.okButton);
            base.Controls.Add(this.listBox);
            base.FormBorderStyle = FormBorderStyle.SizableToolWindow;
            base.MaximizeBox = false;
            base.MinimizeBox = false;
            base.Name = "ListBoxDialog";
            base.SizeGripStyle = SizeGripStyle.Hide;
            base.StartPosition = FormStartPosition.CenterParent;
            this.Text = "Please Select...";
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            base.ResumeLayout(false);
        }

        private void listBox_DoubleClick(object sender, EventArgs e)
        {
            this.Decide();
        }

        private void listBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (((e.KeyChar == '\r') || (e.KeyChar == '\r')) || (e.KeyChar == '+'))
            {
                this.Decide();
            }
        }

        private void listBox_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Decide();
        }

        private void searchButton_Click(object sender, EventArgs e)
        {
            if (this.textBox1.Text == string.Empty)
            {
                this.listBox.DataSource = this.list;
            }
            else
            {
                ArrayList list = new ArrayList();
                if (this.searchComboBox.SelectedIndex == 0)
                {
                    for (int i = 0; i < this.list.Count; i++)
                    {
                        if (((SelectBoxItem) this.list[i]).Name.StartsWith(this.textBox1.Text))
                        {
                            list.Add(this.list[i]);
                        }
                    }
                }
                else if (this.searchComboBox.SelectedIndex == 1)
                {
                    for (int j = 0; j < this.list.Count; j++)
                    {
                        if (((SelectBoxItem) this.list[j]).Name.IndexOf(this.textBox1.Text) != -1)
                        {
                            list.Add(this.list[j]);
                        }
                    }
                }
                else
                {
                    for (int k = 0; k < this.list.Count; k++)
                    {
                        if (((SelectBoxItem) this.list[k]).Name.EndsWith(this.textBox1.Text))
                        {
                            list.Add(this.list[k]);
                        }
                    }
                }
                this.listBox.DataSource = list;
            }
        }

        public int Count
        {
            get
            {
                return this.listBox.Items.Count;
            }
        }

        public int MaxValue
        {
            get
            {
                return this.max;
            }
        }

        public int MinValue
        {
            get
            {
                return this.min;
            }
        }

        public int SelectedIndex
        {
            get
            {
                return this.listBox.SelectedIndex;
            }
            set
            {
                if (value >= this.listBox.Items.Count)
                {
                    this.listBox.SelectedIndex = this.listBox.Items.Count - 1;
                }
                else if (value < 0)
                {
                    this.listBox.SelectedIndex = 0;
                }
                else
                {
                    this.listBox.SelectedIndex = value;
                }
            }
        }

        public string SelectedName
        {
            get
            {
                if ((this.listBox.SelectedIndex >= 0) && (this.listBox.SelectedIndex < this.listBox.Items.Count))
                {
                    SelectBoxItem selectedItem = (SelectBoxItem) this.listBox.SelectedItem;
                    return selectedItem.Name;
                }
                return string.Empty;
            }
            set
            {
                if ((this.listBox.SelectedIndex >= 0) && (this.listBox.SelectedIndex < this.listBox.Items.Count))
                {
                    SelectBoxItem selectedItem = (SelectBoxItem) this.listBox.SelectedItem;
                    selectedItem.Name = value;
                }
            }
        }

        public int SelectedValue
        {
            get
            {
                if ((this.listBox.SelectedIndex >= 0) && (this.listBox.SelectedIndex < this.listBox.Items.Count))
                {
                    return (int) this.listBox.SelectedValue;
                }
                return 0;
            }
            set
            {
                try
                {
                    this.listBox.SelectedValue = value;
                }
                catch
                {
                    this.listBox.SelectedIndex = 0;
                }
            }
        }
    }
}

