﻿namespace POKEMON_BW2
{
    using System;
    using System.Reflection;

    public class PlaceData
    {
        private byte[] data = new byte[0xe8];
        public const int PCOUNT = 0x38;
        public const int SIZE = 0xe8;

        public int GetMaxLv(int index)
        {
            return this.data[(8 + (index * 4)) + 3];
        }

        public int GetMinLv(int index)
        {
            return this.data[(8 + (index * 4)) + 2];
        }

        public int GetPokemon(int index)
        {
            return (this.data[8 + (index * 4)] + (this.data[(8 + (index * 4)) + 1] * 0x100));
        }

        public void SetMaxLv(int index, int value)
        {
            this.data[(8 + (index * 4)) + 3] = (byte) value;
        }

        public void SetMinLv(int index, int value)
        {
            this.data[(8 + (index * 4)) + 2] = (byte) value;
        }

        public void SetPokemon(int index, int value)
        {
            this.data[8 + (index * 4)] = (byte) (value & 0xff);
            this.data[(8 + (index * 4)) + 1] = (byte) ((value >> 8) & 0xff);
        }

        public byte[] Data
        {
            get
            {
                return this.data;
            }
            set
            {
                this.data = value;
            }
        }

        public byte this[int i]
        {
            get
            {
                return this.data[i];
            }
            set
            {
                this.data[i] = value;
            }
        }

        public int Length
        {
            get
            {
                return this.data.Length;
            }
        }
    }
}

