﻿namespace POKEMON_BW2
{
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Drawing;
    using System.IO;
    using System.Windows.Forms;

    public class PlaceForm : Form
    {
        private Button cancelButton;
        private DataGridViewTextBoxColumn Column1;
        private DataGridViewTextBoxColumn Column2;
        private DataGridViewTextBoxColumn Column3;
        private DataGridViewTextBoxColumn Column4;
        private IContainer components;
        private DataGridView dgv;
        private GroupBox groupBox1;
        private GroupBox groupBox2;
        private GroupBox groupBox3;
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private Label label5;
        private Label label6;
        private Label label7;
        private Label label8;
        private ValueInputForm lvVIF = new ValueInputForm();
        private Button maxLvButton;
        private Button minLvButton;
        private PlaceData[] myPlace;
        private OpenFileDialog ofd;
        private Button okButton;
        private Panel panel1;
        private ListBox placeListBox;
        private Button pokeButton;
        private ListBoxDialog pokeLBD = new ListBoxDialog();
        private Button readBinButton;
        private int selectedValue;
        private SaveFileDialog sfd;
        private SplitContainer splitContainer1;
        private Button writeBinButton;
        private NumericUpDown x00_NUD;
        private NumericUpDown x01_NUD;
        private NumericUpDown x02_NUD;
        private NumericUpDown x03_NUD;
        private NumericUpDown x04_NUD;
        private NumericUpDown x05_NUD;
        private NumericUpDown x06_NUD;
        private NumericUpDown x07_NUD;

        public PlaceForm(PlaceData[] place)
        {
            this.InitializeComponent();
            this.dgv.Rows.Add(0x38);
            for (int i = 0; i < 12; i++)
            {
                this.dgv[0, i].Value = "Grass " + (i);
            }
            for (int j = 12; j < 0x18; j++)
            {
                this.dgv[0, j].Value = "Doubles (Dark) Grass " + (j - 12);
            }
            for (int k = 0x18; k < 0x24; k++)
            {
                this.dgv[0, k].Value = "Shaking Grass " + (k - 0x18);
            }
            for (int m = 0x24; m < 0x29; m++)
            {
                this.dgv[0, m].Value = "Surfing " + (m - 0x24);
            }
            for (int n = 0x29; n < 0x2e; n++)
            {
                this.dgv[0, n].Value = "Surfing Spot " + (n - 41);
            }
            for (int num6 = 0x2e; num6 < 0x33; num6++)
            {
                this.dgv[0, num6].Value = "Fishing " + (num6 - 0x2E);
            }
            for (int num7 = 0x33; num7 < 0x38; num7++)
            {
                this.dgv[0, num7].Value = "Fishing Spot " + (num7 - 51);
            }
            this.pokeLBD.InitializeArrayList(Program.Poke2List.GetArrayList());
            this.placeListBox.DataSource = (ArrayList) Program.PlaceList.GetArrayList().Clone();
            this.placeListBox.DisplayMember = "Name";
            this.placeListBox.ValueMember = "Value";
            this.myPlace = new PlaceData[place.Length];
            for (int num8 = 0; num8 < this.myPlace.Length; num8++)
            {
                this.myPlace[num8] = new PlaceData();
                for (int num9 = 0; num9 < 0xe8; num9++)
                {
                    this.myPlace[num8][num9] = place[num8][num9];
                }
            }
            this.placeListBox.SelectedIndex = 0;
            this.placeListBox.SelectedIndexChanged += new EventHandler(this.placeListBox_SelectedIndexChanged);
            this.ReadData((int) this.placeListBox.SelectedValue);
            this.selectedValue = (int) this.placeListBox.SelectedValue;
            this.lvVIF.Adjust = true;
            this.lvVIF.Maximum = 100;
            this.lvVIF.Minimum = 0;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.panel1 = new Panel();
            this.splitContainer1 = new SplitContainer();
            this.placeListBox = new ListBox();
            this.groupBox3 = new GroupBox();
            this.readBinButton = new Button();
            this.writeBinButton = new Button();
            this.groupBox2 = new GroupBox();
            this.x07_NUD = new NumericUpDown();
            this.x06_NUD = new NumericUpDown();
            this.x03_NUD = new NumericUpDown();
            this.x05_NUD = new NumericUpDown();
            this.x02_NUD = new NumericUpDown();
            this.x04_NUD = new NumericUpDown();
            this.x01_NUD = new NumericUpDown();
            this.x00_NUD = new NumericUpDown();
            this.label8 = new Label();
            this.label7 = new Label();
            this.label6 = new Label();
            this.label5 = new Label();
            this.label4 = new Label();
            this.label3 = new Label();
            this.label2 = new Label();
            this.label1 = new Label();
            this.groupBox1 = new GroupBox();
            this.maxLvButton = new Button();
            this.minLvButton = new Button();
            this.pokeButton = new Button();
            this.dgv = new DataGridView();
            this.Column1 = new DataGridViewTextBoxColumn();
            this.Column2 = new DataGridViewTextBoxColumn();
            this.Column3 = new DataGridViewTextBoxColumn();
            this.Column4 = new DataGridViewTextBoxColumn();
            this.okButton = new Button();
            this.cancelButton = new Button();
            this.ofd = new OpenFileDialog();
            this.sfd = new SaveFileDialog();
            this.panel1.SuspendLayout();
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.x07_NUD.BeginInit();
            this.x06_NUD.BeginInit();
            this.x03_NUD.BeginInit();
            this.x05_NUD.BeginInit();
            this.x02_NUD.BeginInit();
            this.x04_NUD.BeginInit();
            this.x01_NUD.BeginInit();
            this.x00_NUD.BeginInit();
            this.groupBox1.SuspendLayout();
            ((ISupportInitialize) this.dgv).BeginInit();
            base.SuspendLayout();
            this.panel1.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Top;
            this.panel1.Controls.Add(this.splitContainer1);
            this.panel1.Location = new Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new Size(0x310, 0x206);
            this.panel1.TabIndex = 0;
            this.splitContainer1.Dock = DockStyle.Fill;
            this.splitContainer1.Location = new Point(0, 0);
            this.splitContainer1.Name = "splitContainer1";
            this.splitContainer1.Panel1.Controls.Add(this.placeListBox);
            this.splitContainer1.Panel2.Controls.Add(this.groupBox3);
            this.splitContainer1.Panel2.Controls.Add(this.groupBox2);
            this.splitContainer1.Panel2.Controls.Add(this.groupBox1);
            this.splitContainer1.Size = new Size(0x310, 0x206);
            this.splitContainer1.SplitterDistance = 0xb6;
            this.splitContainer1.TabIndex = 0;
            this.placeListBox.Dock = DockStyle.Fill;
            this.placeListBox.FormattingEnabled = true;
            this.placeListBox.ItemHeight = 12;
            this.placeListBox.Location = new Point(0, 0);
            this.placeListBox.Name = "placeListBox";
            this.placeListBox.Size = new Size(0xb6, 0x1fc);
            this.placeListBox.TabIndex = 0;
            this.groupBox3.Controls.Add(this.readBinButton);
            this.groupBox3.Controls.Add(this.writeBinButton);
            this.groupBox3.Location = new Point(400, 0x1c9);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new Size(0xc3, 0x3a);
            this.groupBox3.TabIndex = 3;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Encounter Slot Backup (.bin)";
            this.readBinButton.Location = new Point(100, 0x16);
            this.readBinButton.Name = "readBinButton";
            this.readBinButton.Size = new Size(0x4b, 0x17);
            this.readBinButton.TabIndex = 4;
            this.readBinButton.Text = "Import";
            this.readBinButton.UseVisualStyleBackColor = true;
            this.readBinButton.Click += new EventHandler(this.readBinButton_Click);
            this.writeBinButton.Location = new Point(0x13, 0x16);
            this.writeBinButton.Name = "writeBinButton";
            this.writeBinButton.Size = new Size(0x4b, 0x17);
            this.writeBinButton.TabIndex = 3;
            this.writeBinButton.Text = "Export";
            this.writeBinButton.UseVisualStyleBackColor = true;
            this.writeBinButton.Click += new EventHandler(this.writeBinButton_Click);
            this.groupBox2.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom;
            this.groupBox2.Controls.Add(this.x07_NUD);
            this.groupBox2.Controls.Add(this.x06_NUD);
            this.groupBox2.Controls.Add(this.x03_NUD);
            this.groupBox2.Controls.Add(this.x05_NUD);
            this.groupBox2.Controls.Add(this.x02_NUD);
            this.groupBox2.Controls.Add(this.x04_NUD);
            this.groupBox2.Controls.Add(this.x01_NUD);
            this.groupBox2.Controls.Add(this.x00_NUD);
            this.groupBox2.Controls.Add(this.label8);
            this.groupBox2.Controls.Add(this.label7);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new Point(3, 0x1c9);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new Size(0x187, 0x3a);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Habitat Header";
            this.x07_NUD.Location = new Point(330, 30);
            int[] bits = new int[4];
            bits[0] = 0xff;
            this.x07_NUD.Maximum = new decimal(bits);
            this.x07_NUD.Name = "x07_NUD";
            this.x07_NUD.Size = new Size(40, 0x13);
            this.x07_NUD.TabIndex = 8;
            this.x06_NUD.Location = new Point(0x11c, 30);
            int[] numArray2 = new int[4];
            numArray2[0] = 0xff;
            this.x06_NUD.Maximum = new decimal(numArray2);
            this.x06_NUD.Name = "x06_NUD";
            this.x06_NUD.Size = new Size(40, 0x13);
            this.x06_NUD.TabIndex = 8;
            this.x03_NUD.Location = new Point(0x92, 30);
            int[] numArray3 = new int[4];
            numArray3[0] = 0xff;
            this.x03_NUD.Maximum = new decimal(numArray3);
            this.x03_NUD.Name = "x03_NUD";
            this.x03_NUD.Size = new Size(40, 0x13);
            this.x03_NUD.TabIndex = 8;
            this.x05_NUD.Location = new Point(0xee, 30);
            int[] numArray4 = new int[4];
            numArray4[0] = 0xff;
            this.x05_NUD.Maximum = new decimal(numArray4);
            this.x05_NUD.Name = "x05_NUD";
            this.x05_NUD.Size = new Size(40, 0x13);
            this.x05_NUD.TabIndex = 8;
            this.x02_NUD.Location = new Point(100, 30);
            int[] numArray5 = new int[4];
            numArray5[0] = 0xff;
            this.x02_NUD.Maximum = new decimal(numArray5);
            this.x02_NUD.Name = "x02_NUD";
            this.x02_NUD.Size = new Size(40, 0x13);
            this.x02_NUD.TabIndex = 8;
            this.x04_NUD.Location = new Point(0xc0, 30);
            int[] numArray6 = new int[4];
            numArray6[0] = 0xff;
            this.x04_NUD.Maximum = new decimal(numArray6);
            this.x04_NUD.Name = "x04_NUD";
            this.x04_NUD.Size = new Size(40, 0x13);
            this.x04_NUD.TabIndex = 8;
            this.x01_NUD.Location = new Point(0x36, 30);
            int[] numArray7 = new int[4];
            numArray7[0] = 0xff;
            this.x01_NUD.Maximum = new decimal(numArray7);
            this.x01_NUD.Name = "x01_NUD";
            this.x01_NUD.Size = new Size(40, 0x13);
            this.x01_NUD.TabIndex = 8;
            this.x00_NUD.Location = new Point(8, 30);
            int[] numArray8 = new int[4];
            numArray8[0] = 0xff;
            this.x00_NUD.Maximum = new decimal(numArray8);
            this.x00_NUD.Name = "x00_NUD";
            this.x00_NUD.Size = new Size(40, 0x13);
            this.x00_NUD.TabIndex = 8;
            this.label8.AutoSize = true;
            this.label8.Location = new Point(0x148, 15);
            this.label8.Name = "label8";
            this.label8.Size = new Size(0x35, 12);
            this.label8.TabIndex = 7;
            this.label8.Text = "Item*";
            this.label7.AutoSize = true;
            this.label7.Location = new Point(0x11a, 15);
            this.label7.Name = "label7";
            this.label7.Size = new Size(0x25, 12);
            this.label7.TabIndex = 6;
            this.label7.Text = "Fish*";
            this.label6.AutoSize = true;
            this.label6.Location = new Point(0xec, 15);
            this.label6.Name = "label6";
            this.label6.Size = new Size(0x19, 12);
            this.label6.TabIndex = 5;
            this.label6.Text = "Fish";
            this.label5.AutoSize = true;
            this.label5.Location = new Point(190, 15);
            this.label5.Name = "label5";
            this.label5.Size = new Size(0x1d, 12);
            this.label5.TabIndex = 4;
            this.label5.Text = "Surf*";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(0x90, 15);
            this.label4.Name = "label4";
            this.label4.Size = new Size(0x1d, 12);
            this.label4.TabIndex = 3;
            this.label4.Text = "Surf";
            this.label3.AutoSize = true;
            this.label3.Location = new Point(100, 15);
            this.label3.Name = "label3";
            this.label3.Size = new Size(0x1d, 12);
            this.label3.TabIndex = 2;
            this.label3.Text = "Shake";
            this.label2.AutoSize = true;
            this.label2.Location = new Point(0x34, 15);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x1d, 12);
            this.label2.TabIndex = 1;
            this.label2.Text = "Double";
            this.label1.AutoSize = true;
            this.label1.Location = new Point(6, 15);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 12);
            this.label1.TabIndex = 0;
            this.label1.Text = "Regular";
            this.groupBox1.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Top;
            this.groupBox1.Controls.Add(this.maxLvButton);
            this.groupBox1.Controls.Add(this.minLvButton);
            this.groupBox1.Controls.Add(this.pokeButton);
            this.groupBox1.Controls.Add(this.dgv);
            this.groupBox1.Location = new Point(3, 3);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new Size(0x250, 0x1c0);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Encounter Slot Data";
            this.maxLvButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.maxLvButton.Location = new Point(0x1ed, 0x1a3);
            this.maxLvButton.Name = "maxLvButton";
            this.maxLvButton.Size = new Size(90, 0x17);
            this.maxLvButton.TabIndex = 3;
            this.maxLvButton.Text = "Edit Max Level";
            this.maxLvButton.UseVisualStyleBackColor = true;
            this.maxLvButton.Click += new EventHandler(this.maxLvButton_Click);
            this.minLvButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.minLvButton.Location = new Point(0x18d, 0x1a3);
            this.minLvButton.Name = "minLvButton";
            this.minLvButton.Size = new Size(90, 0x17);
            this.minLvButton.TabIndex = 2;
            this.minLvButton.Text = "Edit Min Level";
            this.minLvButton.UseVisualStyleBackColor = true;
            this.minLvButton.Click += new EventHandler(this.minLvButton_Click);
            this.pokeButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.pokeButton.Location = new Point(0x12d, 0x1a3);
            this.pokeButton.Name = "pokeButton";
            this.pokeButton.Size = new Size(90, 0x17);
            this.pokeButton.TabIndex = 1;
            this.pokeButton.Text = "Edit Pokémon";
            this.pokeButton.UseVisualStyleBackColor = true;
            this.pokeButton.Click += new EventHandler(this.pokeButton_Click);
            this.dgv.AllowUserToAddRows = false;
            this.dgv.AllowUserToDeleteRows = false;
            this.dgv.AllowUserToResizeColumns = false;
            this.dgv.AllowUserToResizeRows = false;
            this.dgv.Anchor = AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Top;
            this.dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.AutoSize;
            this.dgv.Columns.AddRange(new DataGridViewColumn[] { this.Column1, this.Column2, this.Column3, this.Column4 });
            this.dgv.Location = new Point(3, 15);
            this.dgv.Name = "dgv";
            this.dgv.ReadOnly = true;
            this.dgv.RowHeadersVisible = false;
            this.dgv.RowTemplate.Height = 0x15;
            this.dgv.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            this.dgv.Size = new Size(0x24a, 0x18e);
            this.dgv.TabIndex = 0;
            this.Column1.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            this.Column1.HeaderText = "Slot";
            this.Column1.Name = "Column1";
            this.Column1.ReadOnly = true;
            this.Column1.Resizable = DataGridViewTriState.False;
            this.Column1.SortMode = DataGridViewColumnSortMode.NotSortable;
            this.Column2.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            this.Column2.HeaderText = "Pokémon";
            this.Column2.Name = "Column2";
            this.Column2.ReadOnly = true;
            this.Column2.Resizable = DataGridViewTriState.False;
            this.Column2.SortMode = DataGridViewColumnSortMode.NotSortable;
            this.Column3.HeaderText = "Min Level";
            this.Column3.Name = "Column3";
            this.Column3.ReadOnly = true;
            this.Column3.Resizable = DataGridViewTriState.False;
            this.Column3.SortMode = DataGridViewColumnSortMode.NotSortable;
            this.Column3.Width = 80;
            this.Column4.HeaderText = "Max Level";
            this.Column4.Name = "Column4";
            this.Column4.ReadOnly = true;
            this.Column4.Resizable = DataGridViewTriState.False;
            this.Column4.SortMode = DataGridViewColumnSortMode.NotSortable;
            this.Column4.Width = 80;
            this.okButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.okButton.Location = new Point(0x268, 0x210);
            this.okButton.Name = "okButton";
            this.okButton.Size = new Size(0x4b, 0x17);
            this.okButton.TabIndex = 1;
            this.okButton.Text = "OK";
            this.okButton.UseVisualStyleBackColor = true;
            this.okButton.Click += new EventHandler(this.okButton_Click);
            this.cancelButton.Anchor = AnchorStyles.Right | AnchorStyles.Bottom;
            this.cancelButton.Location = new Point(0x2b9, 0x210);
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.Size = new Size(0x4b, 0x17);
            this.cancelButton.TabIndex = 2;
            this.cancelButton.Text = "Cancel";
            this.cancelButton.UseVisualStyleBackColor = true;
            this.cancelButton.Click += new EventHandler(this.cancelButton_Click);
            this.ofd.Filter = "Encounter Slot File|*.bin|All Files|*.*";
            this.sfd.Filter = "Encounter Slot File|*.bin|Slots|*.*";
            base.AutoScaleDimensions = new SizeF(6f, 12f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x310, 0x233);
            base.Controls.Add(this.cancelButton);
            base.Controls.Add(this.okButton);
            base.Controls.Add(this.panel1);
            this.MinimumSize = new Size(800, 600);
            base.Name = "PlaceForm";
            base.SizeGripStyle = SizeGripStyle.Hide;
            base.StartPosition = FormStartPosition.CenterParent;
            this.Text = "Encounter Slot Editor";
            this.panel1.ResumeLayout(false);
            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.x07_NUD.EndInit();
            this.x06_NUD.EndInit();
            this.x03_NUD.EndInit();
            this.x05_NUD.EndInit();
            this.x02_NUD.EndInit();
            this.x04_NUD.EndInit();
            this.x01_NUD.EndInit();
            this.x00_NUD.EndInit();
            this.groupBox1.ResumeLayout(false);
            ((ISupportInitialize) this.dgv).EndInit();
            base.ResumeLayout(false);
        }

        private void maxLvButton_Click(object sender, EventArgs e)
        {
            if (this.dgv.SelectedRows.Count > 0)
            {
                int selectedValue = (int) this.placeListBox.SelectedValue;
                int count = this.dgv.SelectedRows.Count;
                this.lvVIF.Value = (int) this.dgv.SelectedRows[count - 1].Cells[3].Value;
                if (this.lvVIF.ShowDialog() == DialogResult.OK)
                {
                    for (int i = 0; i < count; i++)
                    {
                        int rowIndex = this.dgv.SelectedRows[i].Cells[0].RowIndex;
                        this.myPlace[selectedValue].SetMaxLv(rowIndex, this.lvVIF.Value);
                    }
                    this.ReadData(selectedValue);
                }
            }
        }

        private void minLvButton_Click(object sender, EventArgs e)
        {
            if (this.dgv.SelectedRows.Count > 0)
            {
                int selectedValue = (int) this.placeListBox.SelectedValue;
                int count = this.dgv.SelectedRows.Count;
                this.lvVIF.Value = (int) this.dgv.SelectedRows[count - 1].Cells[2].Value;
                if (this.lvVIF.ShowDialog() == DialogResult.OK)
                {
                    for (int i = 0; i < count; i++)
                    {
                        int rowIndex = this.dgv.SelectedRows[i].Cells[0].RowIndex;
                        this.myPlace[selectedValue].SetMinLv(rowIndex, this.lvVIF.Value);
                    }
                    this.ReadData(selectedValue);
                }
            }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.WriteData(this.selectedValue);
            base.DialogResult = DialogResult.OK;
        }

        private void placeListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.placeListBox.SelectedIndex < 0)
            {
                this.placeListBox.SelectedIndex = 0;
            }
            else if (this.placeListBox.SelectedIndex >= this.placeListBox.Items.Count)
            {
                this.placeListBox.SelectedIndex = this.placeListBox.Items.Count - 1;
            }
            this.WriteData(this.selectedValue);
            this.ReadData((int) this.placeListBox.SelectedValue);
            this.selectedValue = (int) this.placeListBox.SelectedValue;
        }

        private void pokeButton_Click(object sender, EventArgs e)
        {
            if (this.dgv.SelectedRows.Count > 0)
            {
                int selectedValue = (int) this.placeListBox.SelectedValue;
                int count = this.dgv.SelectedRows.Count;
                this.pokeLBD.SelectedValue = Program.Poke2List.SearchByName((string) this.dgv.SelectedRows[count - 1].Cells[1].Value);
                if (this.pokeLBD.ShowDialog() == DialogResult.OK)
                {
                    for (int i = 0; i < count; i++)
                    {
                        int rowIndex = this.dgv.SelectedRows[i].Cells[0].RowIndex;
                        this.myPlace[selectedValue].SetPokemon(rowIndex, this.pokeLBD.SelectedValue);
                    }
                    this.ReadData(selectedValue);
                }
            }
        }

        private void readBinButton_Click(object sender, EventArgs e)
        {
            this.ofd.FileName = ((SelectBoxItem) this.placeListBox.SelectedItem).Name + ".bin";
            if (this.ofd.ShowDialog() == DialogResult.OK)
            {
                int selectedValue = (int) this.placeListBox.SelectedValue;
                byte[] buffer = File.ReadAllBytes(this.ofd.FileName);
                for (int i = 0; i < 0xe8; i++)
                {
                    this.myPlace[selectedValue][i] = buffer[i];
                }
                this.ReadData(selectedValue);
            }
        }

        private void ReadData(int index)
        {
            for (int i = 0; i < 0x38; i++)
            {
                this.dgv[1, i].Value = Program.Poke2List.SearchByValue(this.myPlace[index].GetPokemon(i));
                this.dgv[2, i].Value = this.myPlace[index].GetMinLv(i);
                this.dgv[3, i].Value = this.myPlace[index].GetMaxLv(i);
            }
            this.x00_NUD.Value = this.myPlace[index][0];
            this.x01_NUD.Value = this.myPlace[index][1];
            this.x02_NUD.Value = this.myPlace[index][2];
            this.x03_NUD.Value = this.myPlace[index][3];
            this.x04_NUD.Value = this.myPlace[index][4];
            this.x05_NUD.Value = this.myPlace[index][5];
            this.x06_NUD.Value = this.myPlace[index][6];
            this.x07_NUD.Value = this.myPlace[index][7];
        }

        private void writeBinButton_Click(object sender, EventArgs e)
        {
            this.sfd.FileName = ((SelectBoxItem) this.placeListBox.SelectedItem).Name + ".bin";
            if (this.sfd.ShowDialog() == DialogResult.OK)
            {
                int selectedValue = (int) this.placeListBox.SelectedValue;
                byte[] bytes = new byte[0xe8];
                for (int i = 0; i < 0xe8; i++)
                {
                    bytes[i] = this.myPlace[selectedValue][i];
                }
                File.WriteAllBytes(this.sfd.FileName, bytes);
            }
        }

        private void WriteData(int index)
        {
            this.myPlace[index][0] = (byte) this.x00_NUD.Value;
            this.myPlace[index][1] = (byte) this.x01_NUD.Value;
            this.myPlace[index][2] = (byte) this.x02_NUD.Value;
            this.myPlace[index][3] = (byte) this.x03_NUD.Value;
            this.myPlace[index][4] = (byte) this.x04_NUD.Value;
            this.myPlace[index][5] = (byte) this.x05_NUD.Value;
            this.myPlace[index][6] = (byte) this.x06_NUD.Value;
            this.myPlace[index][7] = (byte) this.x07_NUD.Value;
        }

        public PlaceData[] Place
        {
            get
            {
                return this.myPlace;
            }
        }
    }
}

