﻿namespace POKEMON_BW2
{
    using BT;
    using System;
    using System.Reflection;

    public class SkillData
    {
        private byte[] data = new byte[0x24];
        public const int FCOUNT = 3;
        public const int SIZE = 0x24;

        public int GetFluctuationProbability(int index)
        {
            return this.data[0x1b + index];
        }

        public int GetFluctuationStatus(int index)
        {
            return this.data[0x15 + index];
        }

        public int GetFluctuationValue(int index)
        {
            return BT.Convert.ToSbyte(this.data[0x18 + index]);
        }

        public void SetFluctuationProbability(int index, int value)
        {
            this.data[0x1b + index] = (byte) value;
        }

        public void SetFluctuationStatus(int index, int value)
        {
            this.data[0x15 + index] = (byte) value;
        }

        public void SetFluctuationValue(int index, int value)
        {
            this.data[0x18 + index] = (byte) value;
        }

        public int Assort
        {
            get
            {
                return this.data[2];
            }
            set
            {
                this.data[2] = (byte) value;
            }
        }

        public int Category
        {
            get
            {
                return this.data[1];
            }
            set
            {
                this.data[1] = (byte) value;
            }
        }

        public int ConditionCode
        {
            get
            {
                return (this.data[8] + (this.data[9] * 0x100));
            }
            set
            {
                this.data[8] = (byte) (value & 0xff);
                this.data[9] = (byte) ((value >> 8) & 0xff);
            }
        }

        public int ConditionProbability
        {
            get
            {
                return this.data[10];
            }
            set
            {
                this.data[10] = (byte) value;
            }
        }

        public byte[] Data
        {
            get
            {
                return this.data;
            }
            set
            {
                this.data = value;
            }
        }

        public int EffectCode
        {
            get
            {
                return (this.data[0x10] + (this.data[0x11] * 0x100));
            }
            set
            {
                this.data[0x10] = (byte) (value & 0xff);
                this.data[0x11] = (byte) ((value >> 8) & 0xff);
            }
        }

        public int Fatal
        {
            get
            {
                return this.data[14];
            }
            set
            {
                this.data[14] = (byte) value;
            }
        }

        public int FluctuationByDamage
        {
            get
            {
                return BT.Convert.ToSbyte(this.data[0x12]);
            }
            set
            {
                this.data[0x12] = (byte) value;
            }
        }

        public int FluctuationByHP
        {
            get
            {
                return BT.Convert.ToSbyte(this.data[0x13]);
            }
            set
            {
                this.data[0x13] = (byte) value;
            }
        }

        public int Hit
        {
            get
            {
                return this.data[4];
            }
            set
            {
                this.data[4] = (byte) value;
            }
        }

        public byte this[int i]
        {
            get
            {
                return this.data[i];
            }
            set
            {
                this.data[i] = value;
            }
        }

        public int Length
        {
            get
            {
                return this.data.Length;
            }
        }

        public int MaxRepeat
        {
            get
            {
                return (this.data[7] / 0x10);
            }
            set
            {
                this.data[7] = (byte) ((this.data[7] & 15) + (value * 0x10));
            }
        }

        public int MaxTurn
        {
            get
            {
                return this.data[13];
            }
            set
            {
                this.data[13] = (byte) value;
            }
        }

        public int MinRepeat
        {
            get
            {
                return (this.data[7] % 0x10);
            }
            set
            {
                this.data[7] = (byte) ((this.data[7] & 240) + value);
            }
        }

        public int MinTurn
        {
            get
            {
                return this.data[12];
            }
            set
            {
                this.data[12] = (byte) value;
            }
        }

        public int Power
        {
            get
            {
                return this.data[3];
            }
            set
            {
                this.data[3] = (byte) value;
            }
        }

        public int PP
        {
            get
            {
                return this.data[5];
            }
            set
            {
                this.data[5] = (byte) value;
            }
        }

        public int Priority
        {
            get
            {
                return BT.Convert.ToSbyte(this.data[6]);
            }
            set
            {
                this.data[6] = (byte) value;
            }
        }

        public int Target
        {
            get
            {
                return this.data[20];
            }
            set
            {
                this.data[20] = (byte) value;
            }
        }

        public int Type
        {
            get
            {
                return this.data[0];
            }
            set
            {
                this.data[0] = (byte) value;
            }
        }

        public int Unkown0B
        {
            get
            {
                return this.data[11];
            }
            set
            {
                this.data[11] = (byte) value;
            }
        }

        public int Unkown1E
        {
            get
            {
                return this.data[30];
            }
            set
            {
                this.data[30] = (byte) value;
            }
        }

        public int Unkown1F
        {
            get
            {
                return this.data[0x1f];
            }
            set
            {
                this.data[0x1f] = (byte) value;
            }
        }

        public int Unkown20
        {
            get
            {
                return this.data[0x20];
            }
            set
            {
                this.data[0x20] = (byte) value;
            }
        }

        public int Unkown21
        {
            get
            {
                return this.data[0x21];
            }
            set
            {
                this.data[0x21] = (byte) value;
            }
        }

        public int Wince
        {
            get
            {
                return this.data[15];
            }
            set
            {
                this.data[15] = (byte) value;
            }
        }
    }
}

