﻿namespace POKEMON_BW2
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class ValueInputForm : Form
    {
        private Button cancelButton;
        private IContainer components;
        private bool myAdjust;
        private Button okButton;
        private NumericUpDown valueNUD;

        public ValueInputForm()
        {
            this.InitializeComponent();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.valueNUD = new NumericUpDown();
            this.okButton = new Button();
            this.cancelButton = new Button();
            this.valueNUD.BeginInit();
            base.SuspendLayout();
            this.valueNUD.Location = new Point(12, 12);
            int[] bits = new int[4];
            bits[0] = 0xffff;
            this.valueNUD.Maximum = new decimal(bits);
            this.valueNUD.Name = "valueNUD";
            this.valueNUD.Size = new Size(0x4b, 0x13);
            this.valueNUD.TabIndex = 0;
            this.okButton.Location = new Point(0x5d, 9);
            this.okButton.Name = "okButton";
            this.okButton.Size = new Size(0x4b, 0x17);
            this.okButton.TabIndex = 1;
            this.okButton.Text = "OK";
            this.okButton.UseVisualStyleBackColor = true;
            this.okButton.Click += new EventHandler(this.okButton_Click);
            this.cancelButton.DialogResult = DialogResult.Cancel;
            this.cancelButton.Location = new Point(0xae, 9);
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.Size = new Size(0x4b, 0x17);
            this.cancelButton.TabIndex = 2;
            this.cancelButton.Text = "Cancel";
            this.cancelButton.UseVisualStyleBackColor = true;
            this.cancelButton.Click += new EventHandler(this.cancelButton_Click);
            base.AcceptButton = this.okButton;
            base.AutoScaleDimensions = new SizeF(6f, 12f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.CancelButton = this.cancelButton;
            base.ClientSize = new Size(0x103, 0x2b);
            base.Controls.Add(this.cancelButton);
            base.Controls.Add(this.okButton);
            base.Controls.Add(this.valueNUD);
            base.FormBorderStyle = FormBorderStyle.FixedSingle;
            base.MaximizeBox = false;
            base.Name = "ValueInputForm";
            base.StartPosition = FormStartPosition.CenterParent;
            this.Text = "Please Input...";
            base.Activated += new EventHandler(this.ValueInputForm_Activated);
            this.valueNUD.EndInit();
            base.ResumeLayout(false);
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.OK;
        }

        private void ValueInputForm_Activated(object sender, EventArgs e)
        {
            this.valueNUD.Focus();
            this.valueNUD.Select(0, this.valueNUD.ToString().Length);
        }

        public bool Adjust
        {
            set
            {
                this.myAdjust = value;
            }
        }

        public int Maximum
        {
            get
            {
                return (int) this.valueNUD.Maximum;
            }
            set
            {
                this.valueNUD.Maximum = value;
            }
        }

        public int Minimum
        {
            get
            {
                return (int) this.valueNUD.Minimum;
            }
            set
            {
                this.valueNUD.Minimum = value;
            }
        }

        public int Value
        {
            get
            {
                return (int) this.valueNUD.Value;
            }
            set
            {
                if (this.myAdjust)
                {
                    if (this.Maximum < value)
                    {
                        this.valueNUD.Value = this.Maximum;
                        return;
                    }
                    if (this.Minimum > value)
                    {
                        this.valueNUD.Value = this.Minimum;
                        return;
                    }
                }
                this.valueNUD.Value = value;
            }
        }
    }
}

